import java.util.LinkedList;
import java.util.List;
 
public class Cruise implements Machine {
    private GUI myGUI;
    private boolean on_state = 	true;
    private boolean cruise_state = 	false;
 
    @Override
    public void setGUI(GUI gui) {
        myGUI = gui;
        updateGUI();
    }
 
    @Override
    public String[] getInputs() {
        String inputs[] = {
          "on",
          "off",
          "cruise",
          "brake",
          "standby",
        };
        return inputs;
    }
 
    @Override
    public String[] getOutputs() {
        String outputs[] = {
          "on",
          "cruise"
        };
        return outputs;
    }
 
    @Override
    public void react(String input) {
        if (true) {
            if (input.equals("off")) {
                this.on_state = false;
                this.cruise_state = false;
                updateGUI();
                return;
            }
        }
        if (!on_state) {
            if (input.equals("on")) {
                this.on_state = true;
                this.cruise_state = false;
                updateGUI();
                return;
            }
        }
        if (on_state) {
            if (input.equals("cruise")) {
                this.cruise_state = true;
                updateGUI();
                return;
            }
        }
        if (cruise_state) {
            if (input.equals("brake")) {
                this.cruise_state = false;
                updateGUI();
                return;
            }
        }
        if (cruise_state) {
            if (input.equals("standby")) {
                this.cruise_state = false;
                updateGUI();
                return;
            }
        }
    }
 
    private void updateGUI() {
        List<String> activeOutputs = new LinkedList<String>();
 
        if (this.on_state) {
            activeOutputs.add("on");
        }
        if (this.cruise_state) {
            activeOutputs.add("cruise");
        }
        this.myGUI.setOutputs(activeOutputs);
    }
 
    public static void main(String[] args) {
        Machine m = new Cruise();
        new SwingGUI(m);
    }
}
